# Source for file Integer.php

Documentation is available at Integer.php

1. <?php
2. /*
3. * $Id: Integer.php 1080 2007-02-10 18:17:08Z romanb $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
21. Doctrine::autoload('Doctrine_Hook_Parser_Complex');
22. /**
23. * Doctrine_Hook_Integer
24. *
25. * @package Doctrine
26. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
27. * @category Object Relational Mapping
28. * @link www.phpdoctrine.com
29. * @since 1.0
30. * @version $Revision: 1080 $
31. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32. */
33. class Doctrine_Hook_Integer extends Doctrine_Hook_Parser_Complex
34. {
35. /**
36. * parse
37. * Parses given field and field value to DQL condition
38. * and parameters. This method should always return
39. * prepared statement conditions (conditions that use
40. * placeholders instead of literal values).
41. *
42. * @param string $alias component alias
43. * @param string $field the field name
44. * @param mixed $value the value of the field
45. * @return void
46. */
47. public function parseSingle($alias, $field, $value)
48. {
49. $e = explode(' ', $value);
51. foreach ($e as $v) {
52. $v = trim($v);
54. $e2 = explode('-', $v);
56. $name = $alias. '.' . $field;
58. if (count($e2) == 1) {
59. // one '-' found
61. $a[] = $name . ' = ?';
63. $this->params[] = $v;
64. } else {
65. // more than one '-' found
67. $a[] = '(' . $name . ' > ? AND ' . $name . ' < ?)';
69. $this->params += array($e2[0], $e2[1]);
70. }
72. }
73. return implode(' OR ', $a);
74. }
75. }